<script>
    import axios from 'axios'
    import router from '../router'

    export default {
        data() {
            return {
                username: "",
                password: "",
                message: ""
            }
        },
        methods: {
            async onSubmit() {
                this.message = ""

                if ( this.username && this.password ) {

                    const request = await axios.post( 'https://challenge-calories-api.herokuapp.com/login', { username: this.username, password: this.password },
                    {
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json'
                        }
                    } )
                    .catch( error => {
                        const errorMessage = error?.response?.data?.message

                        if ( errorMessage ) {
                            this.message = errorMessage
                        }
                    } )
                    
                    if ( request?.data?.token ) {
                        sessionStorage.setItem( 'token', request.data.token )
                        router.push( { name: 'home' } )
                    }
                }
            }
        },
        beforeMount() {
            console.log(router)
        }
    }
</script>

<template>
    <div class="grid grid-cols-12">
        <div class="col-span-2"></div>
        <div class="col-span-full m:col-span-8">
            <div v-if="message" class="mb-xl p-l border border-danger rounded text-danger">⚠️ {{ message }}!</div>

            <form @submit.prevent="() => onSubmit()" class="flex flex-col">
                <label>
                    Username
                    <input v-model="username" type="text" name="username" />
                </label>
                <label>
                    Password
                    <input v-model="password" type="password" name="password" />
                </label>
                <button>Sign in</button>
            </form>
        </div>
    </div>
</template>